(*--------------------------------------------------------------------------+
 |                                                                          |
 |                    Bote  outils pour les expressions                   |
 |                                                                          |
 |  M. Quercia, le 24/08/96                                                 |
 +--------------------------------------------------------------------------+*)

type 'a expression =
| Const of 'a                                 (* constante *)
| Var   of string                             (* variable  *)
| Fct   of string * ('a expression)           (* fonction, argument *)
| CL    of ('a * 'a expression) list          (* comb. linaire     *)
| PG    of ('a * 'a expression) list          (* produit gnralis *)
;;

value expression : string -> float expression;;
(* "expression chaine" interprte "chaine" comme une expression arithmtique
   et renvoie l'arbre correspondant. Les oprateurs "+,-,*,/" associent 
   gauche et "^" associe  droite (je trouve cette convention idiote mais
   le reste de l'humanit semble y tenir) *)

value print_exp : float expression -> unit;;
(* "print_exp e" imprime "e" sous forme graphique.
   Les fonctions d'impression sont celles de la bibliothque "format" *)

value feval : string -> float -> float expression;;
value fder  : string -> float expression -> float expression;;
(* "feval f c" calcule "f(c)", "fder f u" calcule "f'(u)" *)
